{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Обработка цветовой индикации контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}


{$SMARTLINK ON}
{$mode objfpc}

unit rubiroLeds;


interface

uses
  uev3,SysUtils, uev3sysfs;

{
 желтые огни при старте rr-программы
}
var LedsOnStartup:boolean=true;

type

  { TEv3Leds }

  TEv3Leds=class(TEv3)
    private
     LGreen,RGreen,LRed,RRed:TEv3Data;
     type TColors=record lg,rg,lr,rr:integer; end;
     var colors:array of tcolors;
         blinked:boolean;
    public
     //запускается при старте, создает светло-оранжевый цвет
     function start:TEv3Leds;
     // запускается по завершении, ввостанавливает штаный зеленый
     function stop:TEv3Leds;
     // сохраняет текущие цвета в памяти (на вершине стека)
     function push:TEv3Leds;
      // ввостанавливает цвета из памяти (с вершины стека)
     function pop:TEv3Leds;
     // гасит все цвета
     function hide:TEv3Leds;
     {
      при последовательном использовании гасит-ввостанавливает цвета
      применяется для имитация мигания
      не рекомендуется использовать совместно с
      push, pop, hide - возможны аберрации
     }
     function blink:TEv3Leds;
     // ввостанавливает цвета, если они были погашены миганием
     function unblink:TEv3Leds;
    public
      constructor create();
      destructor destroy; override;
      {
       Устанавливает интенсивность всех цветоиндикаторов
       диапазон значений - от 0 до 255 (от минимальной до максимальной интенсивности)
       значение -1 означает оставить соответствующий цвет без изменений
      }
      function All(_leftred,_leftgreen,_rightred,_rightgreen:variant):TEv3Leds;
      // устанавливает интенсивность левых цветоиндикаторов
      function Left(red,green:variant):TEv3Leds;
      // устанавливает интенсивность правых цветоиндикаторов
      function Right(red,green:variant):TEv3Leds;
      // устанавливает интенсивность левого красного цветоиндикатора
      function LeftRed(red:variant):TEv3Leds;
      // устанавливает интенсивность правого красного цветоиндикатора
      function RightRed(red:variant):TEv3Leds;
      // устанавливает интенсивность левого зеленого цветоиндикатора
      function LeftGreen(green:variant):TEv3Leds;
      // устанавливает интенсивность правого зеленого цветоиндикатора
      function RightGreen(green:variant):TEv3Leds;
  end;

  var ev3Leds:TEv3Leds;
implementation
 uses variants;
{ TEv3Leds }

constructor TEv3Leds.create;
begin
  inherited create;
  LGreen:=TEv3Data.Create('/sys/class/leds/ev3:left:green:ev3dev/brightness',nil,ev3ReadWrite);
  LGreen.setIntervals(getInterval,30);
//  LGreen.skipInterval:=true;  ! Убиться АПСТЕНУ, АДИОТ !
  LRed:=TEv3Data.Create('/sys/class/leds/ev3:left:red:ev3dev/brightness',nil,ev3ReadWrite);
  LRed.setIntervals(getInterval,30);
//  LRed.skipInterval:=true;
  RGreen:=TEv3Data.Create('/sys/class/leds/ev3:right:green:ev3dev/brightness',nil,ev3ReadWrite);
  RGreen.setIntervals(getInterval,30);
//  RGreen.skipInterval:=true;
  RRed:=TEv3Data.Create('/sys/class/leds/ev3:right:red:ev3dev/brightness',nil,ev3ReadWrite);
  RRed.setIntervals(getInterval,30);
//  RRed.skipInterval:=true;
  blinked:=false;
end;

destructor TEv3Leds.destroy;
begin
  lgreen.free;
  lred.free;
  RGreen.free;
  rred.free;
  inherited destroy;
end;

function TEv3Leds.start: TEv3Leds;
begin
 //writeln('leds start');
 result:=ev3Leds.all(31,255,31,255);
 //writeln('leds started');
end;

function TEv3Leds.stop: TEv3Leds;
begin
 result:=ev3Leds.all(0,255,0,255);
end;

function TEv3Leds.push: TEv3Leds;
 var c:tcolors;
begin
  result:=self;
  c.lr:=LRed.iData;
  c.lg:=LGreen.iData;
  c.rr:=RRed.iData;
  c.rg:=RGreen.iData;
  setlength(colors,length(colors)+1);
  colors[length(colors)-1]:=c;
end;

function TEv3Leds.pop: TEv3Leds;
 var c:tcolors;
begin
  result:=self;
  if length(colors)=0 then exit;
  c:=colors[length(colors)-1];
  setlength(colors,length(colors)-1);
  all(c.lr,c.lg,c.rr,c.rg);
end;

function TEv3Leds.hide: TEv3Leds;
begin
 result:=self;
 all(0,0,0,0);
end;

function TEv3Leds.blink: TEv3Leds;
begin
 result:=self;
 if blinked then pop
 else begin push; hide; end;
 blinked:=not blinked;
end;

function TEv3Leds.unblink: TEv3Leds;
begin
  result:=self;
  if blinked then begin pop; blinked:=false; end;
//  writeln(LGreen.iData,' ',' ',LRed.iData,' ',RGreen.iData,' ',RRed.iData);
end;

function TEv3Leds.All(_leftred, _leftgreen, _rightred, _rightgreen: variant
  ): TEv3Leds;
begin
  result:=self;
//  writeln(ptruint(lred));
  if _leftred>=0 then lred.idata:=_leftred;
  if _leftgreen>=0 then lgreen.idata:=_leftgreen;
  if _rightred>=0 then rred.idata:=_rightred;
  if _rightgreen>=0 then RGreen.idata:=_rightgreen;
end;

function TEv3Leds.Left(red, green: variant): TEv3Leds;
begin
  result:=self;
  All(red,green,-1,-1);
end;

function TEv3Leds.Right(red, green: variant): TEv3Leds;
begin
  result:=self;
  All(-1,-1,red,green);
end;

function TEv3Leds.LeftRed(red: variant): TEv3Leds;
begin
  result:=self;
  All(red,-1,-1,-1);
end;

function TEv3Leds.RightRed(red: variant): TEv3Leds;
begin
  result:=self;
  All(-1,-1,red,-1);
end;

function TEv3Leds.LeftGreen(green: variant): TEv3Leds;
begin
  result:=self;
  All(-1,green,-1,-1);
end;

function TEv3Leds.RightGreen(green: variant): TEv3Leds;
begin
  result:=self;
  All(-1,-1,-1,green);
end;

procedure init; begin
  ev3Leds:=TEv3Leds.Create;
  if LedsOnStartup then
   ev3Leds.start;
end;
procedure done; begin
  if LedsOnStartup then
   ev3Leds.stop;
  ev3Leds.free;
end;

initialization
  PushInit(@init);
  PushDone(@done);
end.

